#!/bin/sh

# ==========================================================
# = This script is intended only for Free-SA installation, =
# =       so no variables or error checking done.          =
# ==========================================================

# We've defined only those:
# INSTALLFIL = $(INSTALL) -m 0644 -v
# INSTALLBIN = $(INSTALL) -m 0755 -v
# INSTALLDIR = $(INSTALL) -m 0755 -v -d
# INSTALLODR = $(INSTALL) -m 0700 -v -d

install_failed() {
    echo ""
    echo "INSTALLATION FAILED!"
    echo ""
    exit 1
}

if [ $# -lt 5 ]; then install_failed; fi

TMODE=$2
shift 3

case "$1" in
"-d")
    echo "Installing directory: $2"
    mkdir -p -m $TMODE "$2"
    if [ $? -ne 0 ]; then install_failed; fi
    ;;
*)
    TDIR=$(echo "$@"|rev|cut -d ' ' -f 1|rev)
    ARGCOUNT=$#
    let ARGCOUNT=ARGCOUNT-1
    
    while(true); do
	TFILE="$(echo $1|rev|cut -d '/' -f 1|rev)"
	
	echo "Installing file: '$TFILE' -> '$TDIR'"
	cp "$1" "$TDIR"
	if [ $? -ne 0 ]; then install_failed; fi
	chmod $TMODE "$TDIR/$TFILE"
	if [ $? -ne 0 ]; then install_failed; fi
	
	shift
	let ARGCOUNT=ARGCOUNT-1
	
	if [ $ARGCOUNT -eq 0 ]; then exit 0; fi
    done
    ;;
esac
