#include "global.h"


int main(int argc, char **argv) {
    FILE *Log;
    time_t rsdate, redate;
    short int i;


    SDEBUG();
    /* SA locale and configuration init */
    InitLocale();
    InitConfigWithCL(argc, argv);

    switch (icfg.Mode) {
	case 1: /* Generate reports */
		/* Open, detect and seek to start date log file */
		Log = InitLog();
		/* Seek to start date only if SDate is specified */
		if (icfg.SDate) if (SeekLog(Log, icfg.SDate)) SAexit("No records found");
		
		/* Init reports environment */
		InitReports();
		/* Collect data from log */
		CollectLog(Log, &rsdate, &redate);
		ComputePeriod(rsdate, redate);
		GenerateReports();
		break;
	case 2: /* Show log info */
		ShowLog(InitLog());
		break;
	case 3: /* Delete records from log by date */
		if (icfg.SDate == 0L && icfg.EDate == SAMAXTIMET) SAexit("You should specify dates range (minimum 1 date: start or end)");
		CropLog(InitLog());
		break;
	case 4:
		InitReportsSort();
		ReportIndex();
		break;
    }

#if DEBUG >= 3
    SAdebug("Open file count: %d\nUsers entries count: %d\n", ofcount, icfg.ueCount);
#endif

    for (i = 0; i < icfg.LFcount; i++) free(lfcfgs[i]);

    EDEBUG();
    return(EXIT_SUCCESS);
}
