#include "global.h"


/* UNOPTIMIZED */
struct MailRecord *PFSLReadRecordM(FILE *iLog) {
    char daemonmod[16], tBuf[RECORDSIZE], tDT[SYSLOGDTSIZE];
    char *trs, *pstat;
    unsigned int tMsgid;
    long int tbytes;
    struct MailRecord *t = NULL;


    /* read next string from log */
    while (fgets(tBuf, sizeof(tBuf), iLog) != NULL) {
	/* find beginning of string after message id */
	if ((trs = strchr(&tBuf[SYSLOGDTSIZE], ':')) == NULL) continue;
	if ((trs = strchr(trs + 1L, ':')) == NULL) continue; /* no messsage id */
	else trs += 2L;

	/* read datetime, daemon and module name, message id */
	if (sscanf(tBuf, "%" SYSLOGDTLEN "[^/] %*s %15[^[]%*s %8x%*[^:\n]", tDT, daemonmod, &tMsgid) != 3) continue;

	/* postfix daemon name */
	if (strncmp(&daemonmod[0], "post", 4L) || strncmp(&daemonmod[4], "fix/", 4L)) continue;

	/* find/create mail record by message id */
	t = FindNewMR(tMsgid);

	/* pickup module */
	if (!strncmp(&daemonmod[9], "icku", 4L)) {
	    t->status = 1;
	    SAstrlcpy(t->ip, "127.0.0.1", IPSIZE);
	} else

	/* smtpd module */
	if (!strncmp(&daemonmod[9], "mtpd", 4L)) {
	    if (sscanf(trs, "client=%*[^[]%*c%" IPLEN "[^]]", t->ip) == 1) t->status = 1;
	    /* not check t->status == 1 because no nrcpt inforamtion available, 
	       postfix allow multiple rejects (often one by one) with same message id */
	    else if (sscanf(trs, "reject:%*[^[]%*c%" IPLEN "[^]]%*3c%hd%*[^;]%*[^<]%*c%" USERNAMELEN "[^>]%*[^<]%*c%" URLLEN "[^>]", t->ip, &t->code, t->name, t->url) == 4) {
		    t->bytes = 0;
		    SyslogDTZ(&t->time, tDT, SYSLOGYEAR);
		    t->count = 1;
		    t->stat = 1;
		    t->status = 3;
		}
	} else

	/* qmgr module */
	if (!strncmp(&daemonmod[9], "mgr", 3L)) {
	    if (t->status == 1) {
		if (!sscanf(trs, "from=<%" USERNAMELEN "[^>]", t->name)) SAexit("Can't read username from log");
		if (sscanf(trs, "%*[^>]>, size=%ld, nrcpt=%hd", &tbytes, (short int*)&t->count) == 2) {
		    t->bytes = (double)tbytes;
		    t->status = 2;
		}
	    }
	} else

	/* delivery agent module */
	if (!strncmp(&daemonmod[9], "mtp", 3L) || !strncmp(&daemonmod[9], "ipe", 3L) || !strncmp(&daemonmod[9], "ocal", 4L) || !strncmp(&daemonmod[9], "irtual", 6L)) {
	    if (t->status == 2 && sscanf(trs, "to=<%" URLLEN "[^>]", t->url) == 1 && (pstat = strstr(trs, "status=")) != NULL) {
		switch (pstat[7]) {
		    case 's': t->code = 250; break; /* sent			*/
		    case 'd': t->code = 451; break; /* deferred			*/
		    case 'b':
		    case 'u':
			      t->code = 550; break; /* bounced or undeliverable	*/
		     default: t->code = 600; SAwarning("Unknown stat: %c, please contact developers", pstat[7]); break;
		}

		SyslogDTZ(&t->time, tDT, SYSLOGYEAR);
		t->stat = 0;
		t->status = 3;
	    }
	}

	if (t->status == 3) return t;
	else if (t->status == -1) DelMR(t);
    }


    return NULL;
}
