#include "global.h"


/* UNOPTIMIZED */
struct MailRecord *QMSLReadRecordM(FILE *iLog) {
    char tBuf[RECORDSIZE];
    char *trs;
    struct MailRecord *t = NULL, tMR;


    /* read next string from log */
    while (fgets(tBuf, sizeof(tBuf), iLog) != NULL) {
    	/* find beginning of string (for qmail it's own datetime) */
	if ((trs = strchr(&tBuf[SYSLOGDTSIZE], ':')) == NULL) continue; /* incorrect record */
	else trs += 2L;
    
	/* info msg */
	if (!strncmp((trs + 18L), "info", 4L)) {
	    tMR.name[0] = '-';
	    
	    if (sscanf(trs + 27L, "%u%*8c %lf %*[^<]%*c%" USERNAMELEN "[^>]", &tMR.msgid, &tMR.bytes, tMR.name) >= 2) {
		t = FindNewMR(tMR.msgid);
		if (tMR.name[0] != '-') SAstrlcpy(t->name, tMR.name, USERNAMESIZE);
		t->bytes = tMR.bytes;
		t->status = 1;
	    }
	} else
	
	/* starting delivery */
	if (!strncmp((trs + 18L), "star", 4L)) {
	    if (sscanf(trs + 36L, "%hd%*6c%u%*4c%*s %" URLLEN "s", &tMR.code, &tMR.msgid, tMR.url) == 3)
		if ((t = FindDupMR(tMR.msgid)) != NULL) {
		    SAstrlcpy(t->url, tMR.url, URLSIZE);
		    t->code = tMR.code;
		    t->status = 2;
		}
	} else
	
	/* delivery */
	if (!strncmp((trs + 18L), "deli", 4L)) {
	    if (sscanf(trs, "%ld%*17c%hd%*2c%c", &tMR.time, &tMR.code, &tMR.stat) == 3)
		if ((t = FindMRbyCode(tMR.code)) != NULL) {
		    switch (tMR.stat) {
			case 's': t->code = 250; break;
			case 'd': t->code = 451; break;
			case 'f': t->code = 550; break;
			 default: t->code = 600; SAwarning("Unknown stat: %c, please contact developers", tMR.stat); break;
		    }
		    
		    SAstrlcpy(t->ip, "127.0.0.1", IPSIZE);
		    t->time = tMR.time;
		    t->count = 1;
		    t->stat = 0;
		    t->status = 3;
		    
		    return t;
		}
	} else
	
	/* end msg */
	if (!strncmp((trs + 18L), "end ", 4L))
	    if (sscanf(trs + 26L, "%u", &tMR.msgid) == 1) DelMRs(tMR.msgid);
    }


    return NULL;
}
