#include "global.h"


struct LFreport LF[MAXLFCOUNT];


void ReportLocalFilter(void) {
    FILE *LFR;
    short int i, tIndic;
    time_t tTime;
    double tBytes;
    char turl[URLSIZE];
    int tid, otid;


    /* this function requires Users sorted by id */
    qsort(Users, (size_t)icfg.ueCount, sizeof(struct SAentry), (int (*)(const void *, const void *))compSAentryId);

    for (i = 0; i < icfg.LFcount; i++) {
	/* LF_UNS: close */
	SAfclose(LF[i].file);

	/* LF: sort and generate report only if there is records */
	if (LF[i].all.count) {
	    /* LF_UNS: sort by name(reverse) and datetime(normal,numeric) */
	    SAsystem(CMDSORT, CMDSORT, "-k", "1,1r", "-k", "2,2n", "-o", LF[i].fnames.srt, LF[i].fnames.uns, NULL);
	    /* LF_UNS: delete */
	    SAunlink(LF[i].fnames.uns);
	
	    /* LF_SRT: open */
	    LF[i].file = SAfopenI("r", LF[i].fnames.srt);
	    /* LFR: open */
	    LFR = SAfopenH("../", 'l', lfcfgs[i]->name, rcfg.LFRsort, 1, "%s/lf_%hd.html", icfg.ReportDir, i);
	
	    /* LFR: write main table header */
	    SAfprintf(LFR, "\t<tr><th>%s<th>%s%s%s\n", loc->URL, loc->DnT, (lfcfgs[i]->showbytes) ? "<th>" : "", (lfcfgs[i]->showbytes) ? loc->Bytes : "");
	
	    /* LFR: write user stats depending on showbytes option */
	    if (lfcfgs[i]->showbytes) {
	        for (otid = -1; fscanf(LF[i].file, "%d %ld %s %lf %hd\n", &tid, &tTime, turl, &tBytes, &tIndic) == 5;) {
		    if (otid != tid) {
			SAfprintf(LFR, "%s<tr><th colspan=3>%s\n", (otid != -1) ? "<tr><td class=el>\n" : "", SAentryById(tid)->vname);
			otid = tid;
		    }
		
		    SAfprintf(LFR, "<tr><td><a href=\"%s\">%s</a><td>%s<td class=rt>%s", turl, LimitedURL(turl), GetDT(tTime, "%x&nbsp;%X"), icfg.SAB(tBytes));
		    Indics(LFR, tIndic);
		}
	    } else {
		for (otid = -1; fscanf(LF[i].file, "%d %ld %s %hd\n", &tid, &tTime, turl, &tIndic) == 4;) {
		    if (otid != tid) {
			SAfprintf(LFR, "%s<tr><th colspan=2>%s\n", (otid != -1) ? "<tr><td class=el>\n" : "", SAentryById(tid)->vname);
			otid = tid;
		    }
		
		    SAfprintf(LFR, "<tr><td><a href=\"%s\">%s</a><td>%s", turl, LimitedURL(turl), GetDT(tTime, "%x&nbsp;%X"));
		    Indics(LFR, tIndic);
		}
	    }
	
	    /* LFR: close */
	    SAfcloseH(LFR);
	
	    /* LF_SRT: close and delete */
	    SAfcloseU(LF[i].file, LF[i].fnames.srt);
	} else SAunlink(LF[i].fnames.uns); /* LF_UNS: delete */
    }
}
