#include "global.h"


FILE *tTS1;


void ReportTopSites(void) {
    FILE *TSR, *tTS2;
    char turl[URLSIZE], oturl[URLSIZE] = "\000";
    char idlist[((size_t)(icfg.ueCount)) * 6L];
    double tBytes, urlBytes = 0;
    int tCount, urlNumber = 0, tid, otid = -1;
    short int tIndic, urlIndic = 0;
    int i;
    struct ChartData *TSGRCD = NULL;


    /* this function requires Users sorted by id */
    qsort(Users, (size_t)icfg.ueCount, sizeof(struct SAentry), (int (*)(const void *, const void *))compSAentryId);

    SAfclose(tTS1);

    /* sort by URL and user id */
    SAsystem(CMDSORT, CMDSORT, "-k", "1,2", "-o", rcfg.TSRfnames.srt, rcfg.TSRfnames.uns, NULL);
    SAunlink(rcfg.TSRfnames.uns);

    tTS1 = SAfopenI("r", rcfg.TSRfnames.srt);
    tTS2 = SAfopenI("w", rcfg.TSRfnames.uns);

    while (fscanf(tTS1, "%s %d %d %lf %hd\n", turl, &tid, &tCount, &tBytes, &tIndic) == 5) {
	if (strcmp(oturl, turl)) {
	    if (oturl[0] != '\0') SAfprintf(tTS2, "%s %d %.0f %hd %s\n", oturl, urlNumber, urlBytes, urlIndic, idlist);

	    SAstrlcpy(oturl, turl, sizeof(oturl));
	    SAsnprintf(idlist, sizeof(idlist), "%d", tid);
	    otid = tid;
	    urlNumber = tCount;
	    urlIndic = tIndic;
	    urlBytes = tBytes;
	} else {
	    /* fix for incorrect for us sorting, ex: http://m.ru & http://www.m.ru.net */
	    if (tid != otid) SAsnprintf(&idlist[strlen(idlist)], 6L, " %d", tid);
	    urlNumber += tCount;
	    urlIndic |= tIndic;
	    urlBytes += tBytes;
	}
    }

    /* write last data (because we use postwriting, not prewriting) */
    SAfprintf(tTS2, "%s %d %.0f %hd %s\n", oturl, urlNumber, urlBytes, urlIndic, idlist);

    SAfcloseU(tTS1, rcfg.TSRfnames.srt);
    SAfclose(tTS2);

    /* sort by bytes (or required field) */
    SAsystem(CMDSORT, CMDSORT, "-k", "3,3nr", "-o", rcfg.TSRfnames.srt, rcfg.TSRfnames.uns, NULL);
    SAunlink(rcfg.TSRfnames.uns);

    tTS1 = SAfopenI("r", rcfg.TSRfnames.srt);
    SAsnprintf(turl, sizeof(turl), "%s (%s)", loc->Bytes, loc->Desc);
    TSR = SAfopenH("../", 'r', loc->TopSites, turl, 1, "%s/%s.html", icfg.ReportDir, icfg.TSRname);

    if (cfg.top_sites_svg) {
	TSGRCD = (struct ChartData *)SAmalloc((size_t)(rcfg.TSGR.Top + 1) * sizeof(struct ChartData));
	SVGObject(TSR, icfg.TSRname);
    }

    SAfprintf(TSR, "<tr><th>%s<th>%s<th>%s<th>%s<th>%s\n", 
	      loc->No, loc->URL, loc->Connections, loc->Bytes, loc->Users);
    for (i = 1; fscanf(tTS1, "%s %d %lf %hd ", turl, &tCount, &tBytes, &tIndic) == 4;) {
	SAfprintf(TSR, "<tr><td>%d<td class=lt><a href=\"%s\">%s</a><td>%"SATSEP"d<td>%s<td class=lt>", i++, turl, turl, tCount, icfg.SAB(tBytes));
	
	if (cfg.top_sites_svg && i < rcfg.TSGR.Top + 2) {
	    TSGRCD[i - 2].value = tBytes;
	    /* This memory is not freed later !!! */
	    TSGRCD[i - 2].label = SAstrdup(turl);
	}
	
	do {
	    if (!fscanf(tTS1, "%d%c", &tid, idlist)) SAexit("Can't read usernames from sorted file");
	    SAfprintf(TSR, "%s%s", SAentryById(tid)->vname, idlist[0] == ' ' ? ", " : "");
	} while (idlist[0] != '\n');
	Indics(TSR, tIndic);
	
	if (cfg.top_sites_limit) if (i > cfg.top_sites_limit) break;
    }

    if (cfg.top_sites_svg) {
	TSGRCD[SAmin(i - 1, rcfg.TSGR.Top)].label = NULL;
	SVGReport(TSR, TSGRCD, &rcfg.TSGR, icfg.TSRname, 0);
    }

    SAfcloseH(TSR);
    SAfcloseU(tTS1, rcfg.TSRfnames.srt);
}
