typedef struct SAentry {
    FILE		*file;
    struct SAFNAMES	fnames;
    int			id;
    char		*ip;
    char		*name;
    char		*vname;
    double		bytes;
    int			count;
    int			LFcount[MAXLFCOUNT];
} SAentry;

typedef struct SAusertab {
    char	*iname;
    char	*ename;
} SAusertab;

typedef struct SAB3v {
    const double        vlimit;
    const char          *munit;
    const double        divisor;
} SAB3v;


extern struct SAentry *Users;
extern struct SAB3v SAB3variants[6];


extern int compSAentryName(const struct SAentry *el1, const struct SAentry *el2);
extern int compSAentryId(const struct SAentry *el1, const struct SAentry *el2);
extern int rcompSAentryB(const struct SAentry *el1, const struct SAentry *el2);
extern int compSAusertab(const struct SAusertab *el1, const struct SAusertab *el2);
extern int compSI(const short int *el1, const short int *el2);
extern struct SAentry *SAentryByName(char *sname);
extern struct SAentry *SAentryById(const int id);
extern const char *LimitedURL(const char *lurl);
extern char *FixFileName(char *tfname);
extern void RecipientTolower(char *turl);
extern char *SAB0(double ibytes);
extern char *SAB1(double ibytes);
extern char *SAB2(double ibytes);
extern char *SAB3(double ibytes);
extern char *GetDT(time_t idt, const char *fmt);
extern char *GetD(struct tm *itm, const char *fmt);
extern time_t GetDZT(const char *idate);
extern time_t GetDW(const char *iperiod);
extern void ComputePeriod(time_t rsdate, time_t redate);
extern void IndicsI(FILE *iFile, short int iIndic);
extern void IndicsByIndexI(FILE *iFile, int i);
extern void SAunescape(char *istring);
extern void FormFnames(struct SAFNAMES *fnames, const char *fmt, ...);


#define Indics(x, y)				\
    if (cfg.reports_indicators) {		\
	if (y) { 				\
	    IndicsI((x), (y)); 			\
	} 					\
    }						\
    SAfwrite1((const char *)"\n", 1L, (x));

#define IndicsByIndex(x, y)			\
    if (cfg.reports_indicators) {		\
	IndicsByIndexI((x), (y));		\
    }						\
    SAfwrite1((const char *)"\n", 1L, (x));
