#include "global.h"


double ccBytes = 0, allmBytes[5] = { 0, 0, 0, 0, 0 }, allmSeconds[5] = { 0, 0, 0, 0, 0 };
struct BSC ec[CODESSIZE], all[5] = { { 0.0, 0.0, 0 }, { 0.0, 0.0, 0 }, { 0.0, 0.0, 0 }, { 0.0, 0.0, 0 }, { 0.0, 0.0, 0 } };
int ccCount = 0;


char FilterI(const char *iEntry, const void **iList, const char iMode, const short int iCount);
char FilterI(const char *iEntry, const void **iList, const char iMode, const short int iCount) {
    short int i;


    switch (iMode) {
	case 0:
	case 1:
		for (i = 0; i < iCount; i++) if (strstr(iEntry, (const char *)iList[i]) != NULL) return iMode%2;
		break;
	case 2:
	case 3:
		if (bsearch(&iEntry, iList, (size_t)iCount, sizeof(char *), (int (*)(const void *, const void *))SApstrcmp) != NULL) return iMode%2;
		break;
	case 4:
	case 5:
		for (i = 0; i < iCount; i++) if (!regexec(&(((regex_t *)iList)[i]), iEntry, 0L, NULL, 0)) return iMode%2;
		break;
	case 6:
	case 7:
		for (i = 0; i < iCount; i++) if (!strcmp(&iEntry[strlen(iEntry) - strlen(iList[i])], iList[i])) return iMode%2;
		break;
    }

    return !(iMode%2);
}


/* returns 0 if record must be skipped (it's in exclude list or not in existing include list) */
char Filter(const struct FConfig *fcfg, const char *turl, const char *tip, const char *iname, const short int tcode, const double tbytes, const char tstat, const char tmethod);
char Filter(const struct FConfig *fcfg, const char *turl, const char *tip, const char *iname, const short int tcode, const double tbytes, const char tstat, const char tmethod) {
    if (fcfg->stats != '\0') {
	if (SAgetbit(fcfg->stats, tstat)) {
	    if (fcfg->statMode%2) return 0;
	} else if (!(fcfg->statMode%2)) return 0;
    }

    if (fcfg->bytes) {
	if (tbytes > fcfg->bytes) {
	    if (fcfg->bytesMode%2) return 0;
	} else if (!(fcfg->bytesMode%2)) return 0;
    }

    if (fcfg->methods != NULL) {
	if (strchr(fcfg->methods, (int)tmethod) != NULL) {
	    if (fcfg->methodMode%2) return 0;
	} else if (!(fcfg->methodMode%2)) return 0;
    }

    if (fcfg->codeCount) {
	if ((bsearch(&tcode, fcfg->codes, (size_t)fcfg->codeCount, sizeof(short int), (int (*)(const void *, const void *))compSI)) != NULL) {
	    if (fcfg->codeMode%2) return 0;
	} else if (!(fcfg->codeMode%2)) return 0;
    }

    if (fcfg->inameCount) if (FilterI(iname, fcfg->inames, fcfg->inameMode, fcfg->inameCount)) return 0;
    if (fcfg->urlCount) if (FilterI(turl, fcfg->urls, fcfg->urlMode, fcfg->urlCount)) return 0;
    if (fcfg->ipCount) if (FilterI(tip, fcfg->ips, fcfg->ipMode, fcfg->ipCount)) return 0;

    return 1;
}


short int ComputeIndics(short int tcode, char tmethod, char *turl, char *tip, char *tstat, char *iname, double tbytes) {
    short int tIndic = 0;
    short int i;

    for (i = 0; i < icfg.LFcount; i++) if (Filter(lfcfgs[i], turl, tip, iname, tcode, tbytes, *tstat, tmethod)) SAsetbit(tIndic, i);

    return tIndic;
}


struct SAentry *cures = NULL;
struct SAentry *ComputeUser(char *iname, char *tip) {
    struct hostent *hp;
    struct in_addr resip;
    struct SAusertab ukey, *ures;


    /* Speed up: binary search is many strcmp's, we do only two first */
    if (cures != NULL) {
	if (!strcmp(iname, cures->name)) {
	    if (iname == tip && cures->name == cures->ip) return cures;
	    if (!strcmp(tip, cures->ip)) return cures;
	}
	cures = SAentryByName(iname);
    }

    /* If internal name not found in Users or Users is empty (i.e. 1st iteration) */
    if (cures == NULL) {
	Users = (struct SAentry *)SArealloc((void *)Users, sizeof(struct SAentry) * (icfg.ueCount + 1L));
	cures = &Users[icfg.ueCount];
	cures->id = icfg.ueCount++;
	/* Fill user unsorted file name u_USERNAME.uns if not called from CGI */
	if (cfg.users_report || cfg.top_sites_report) {
	    FormFnames(&cures->fnames, "%s/u_%s.uns", cfg.cache_directory, iname);
	    cures->file = SAfopenI("w", cures->fnames.uns);
	}
	cures->ip = SAstrdup(tip);
	/* Clear (i.e. set to 0) starting from vname up to the end of structure */
	memset((void *)&cures->vname, 0, sizeof(struct SAentry) - offsetof(struct SAentry, vname));
	
	/* cures->name is saved internal name */
	if (iname != tip) cures->name = SAstrdup(iname);
	else {
	    /* If we use IP instead of name and should resolve it then try to fill vuser */
	    if (cfg.username_resolve_ip && inet_pton(AF_INET, iname, &resip) != 0) 
		if ((hp = gethostbyaddr((char *)&resip.s_addr, sizeof(in_addr_t), AF_INET)) != NULL) cures->vname = SAstrdup(hp->h_name);
	    cures->name = cures->ip;
	}
	
	/* If UserTab have entries and we not resolved IP before, then fill vname according it */
	if (icfg.utCount && !cures->vname) {
	    ukey.iname = iname;
	    ures = (struct SAusertab *)bsearch(&ukey, icfg.Usertab, (size_t)icfg.utCount, sizeof(struct SAusertab), (int (*)(const void *, const void *))compSAusertab);
	    if (ures != NULL) cures->vname = ures->ename;
	}
	
	/* If we still not filled vname then fill it with value of name */
	if (!cures->vname) cures->vname = cures->name;
	
	qsort(Users, (size_t)icfg.ueCount, sizeof(struct SAentry), (int (*)(const void *, const void *))compSAentryName);
	/* After sorting we should recover pointer (iname points to tname, so it's not damaged by qsort) */
	cures = SAentryByName(iname);
    }

    return cures;
}


/* Function initial/finish log position: any, but meaningful/any */
void CollectLog(FILE *Log, time_t *rsdate, time_t *redate) {
    char tip[IPSIZE], tname[USERNAMESIZE], tmethod, turl[URLSIZE], tstat;
    double tBytes, tSeconds;
    short int tcode, tIndic;
    struct SAentry *res;
    char *t = NULL, *iname, rr;
    time_t ttime, mindate = SAMAXTIMET, maxdate = 0L;
    int i, rrCount = 0, seCount = 0;


tryagain:
    while((rr = READ_RECORD(Log, &ttime, &tSeconds, tip, &tcode, &tBytes, &tmethod, turl, tname, &tstat))) {
	if (cfg.log_skip_errors) rrCount++;
	
	/* Check if record in specified date range and set min/max date values for computing period */
	if (SAgetbit(LogFormats[cfg.log_format].mode, 1)) {
	    if (ttime > icfg.EDate) break;
	
	    if (!icfg.ueCount) mindate = ttime;
	} else {
	    if (ttime > icfg.EDate) continue;
	
	    if (ttime < mindate) mindate = ttime;
	    if (ttime > maxdate) maxdate = ttime;
	}
	/* For non-seekable only */
	if (ttime < icfg.SDate) continue;
	
	/* Internal name resolution and fix */
	if (!cfg.username_is_preferred || tname[0] == '-') iname = tip;
	else iname = FixFileName(tname);
	
	/* Convert recipient name or URL to lower case */
	if (cfg.recipient_tolower) RecipientTolower(turl);
	
	/* Apply global filter */
	if (icfg.GF) if (!Filter(gfcfg, turl, tip, iname, tcode, tBytes, tstat, tmethod)) continue;
	
	/* Search for internal name in Users */
	res = ComputeUser(iname, tip);
	
	tIndic = ComputeIndics(tcode, tmethod, turl, tip, &tstat, iname, tBytes);
	
	/* LF_UNS: write to file & user LF-stats */
	for (i = 0; i < icfg.LFcount; i++)
	    if (SAgetbit(tIndic, i)) {
		/* write only if limit allows it */
		if (!lfcfgs[i]->limit || res->LFcount[i] < lfcfgs[i]->limit) {
		    if (lfcfgs[i]->showbytes) SAfprintf(LF[i].file, "%d %ld %s %.0f %hd\n", res->id, ttime, turl, tBytes, tIndic);
		    else SAfprintf(LF[i].file, "%d %ld %s %hd\n", res->id, ttime, turl, tIndic);
		}
		res->LFcount[i]++;
		LF[i].all.count++;
		LF[i].all.bytes += tBytes;
	    }
	
	/* SER: collect */
	if (cfg.server_efficiency_report) {
	    if (tstat) {
		i = (int)tstat;
		BSCcollect(all[i], tBytes, tSeconds);
		BSCsetmax(allmBytes[i], tBytes);
		BSCsetmax(allmSeconds[i], tSeconds);
	    } else {
		BSCsetmax(allmBytes[4], tBytes);
		BSCsetmax(allmSeconds[4], tSeconds);
	    }
	
	    if (tcode >= CODESSIZE) SAexit("Unknown code: %hd, please contact developers", tcode);
	    BSCcollect(ec[tcode], tBytes, tSeconds);
	}

	/* Compute total stats */
	BSCcollect(all[0], tBytes, tSeconds);
	
	/* Apply users filter */
	if (icfg.UF) if (!Filter(ufcfg, turl, tip, iname, tcode, tBytes, tstat, tmethod)) continue;

	/* Compute user stats */
	res->bytes += tBytes;
	res->count++;
	
	/* TUR: compute total stats, required for percents in TUR */
	ccBytes += tBytes;
	ccCount++;
	
	if (cfg.users_report || cfg.top_sites_report) {
	    if (tmethod == 'C') {
		memmove(&turl[8], turl, strlen(turl) + 1L);
		memcpy(turl, "https://", 8L);
	    }
	
	    /* Shorten URL (we jump over "http://" or "ftp://" here) */
	    if (!cfg.users_fullurl_report && tmethod != 'C') {
		for (t = &turl[7]; t[0] != '\0' && t[0] != '/'; t++);
		t[0] = '\0';
	    }
	
	    /* Use '/' as separator for proper sorting later */
	    SAfprintf(res->file, "%ld/%.0f/%hd/%c/%s\n", ttime, tBytes, tIndic, tmethod, turl);
	}
	/* No code should be here due to user filter above */
    }

    if (cfg.log_skip_errors) {
	/* If error was detected */
	if (!rr) {
	    /* Align to next record otherwise we may face yet another erroneous record */
	    READ_ALIGN(Log);
	
	    /* The end of file is only reason to stop trying */
	    if (!feof(Log)) {
		seCount++;
		goto tryagain;
	    }
	}
	
	/* Warn user about number of erroneous and all records */
	if (seCount) SAwarning("%'d out of %'d records were skipped", seCount, rrCount + seCount);
    }

#if DEBUG >= 1
    SAdebug("Last date seen: %ld, i.e. %s", ttime, GetDT(ttime, "%x %X"));
#endif

    /* Exit if no records found */
    if (!icfg.ueCount) {
	SArm(cfg.cache_directory);
	SAwarning("No records found");
	exit(EXIT_SUCCESS);
    }

    /* Close log file */
    SAfclose(Log);

    /* Fill real start/end dates */
    *rsdate = mindate;
    if (SAgetbit(LogFormats[cfg.log_format].mode, 1)) *redate = ttime;
    else *redate = maxdate;
}


/* Function initial/finish log position: any/requested if possible */
char SeekLog(FILE *Log, time_t sdate) {
    SAOFF_T rseek = 0L, sseek = 0L, eseek = 0L;
    time_t ttime, mindate, maxdate;


    /* Seek is available only in seekable and linear log */
    if (LogFormats[cfg.log_format].mode == 3) {
	/* Fast check for first and last records dates */
	ShowLogI(Log, &mindate, &maxdate);
	if (mindate >= sdate) {
	    rewind(Log);
	    return 0;
	}
	if (maxdate < sdate) return 1;

	/* Save EOF position as end of 1st range (because ShowLogI seeks to EOF) */
	eseek = SAftell(Log);

	/* Fast (?) binary search */
	for (;;) {
	    /* Break if range is little enough to process it sequentally 
	       (because logs may have records with same time) */
	    if ((eseek - sseek) <= (SAOFF_T)RECORDSIZE) break;
	    /* Seek to middle of range */
	    SAfseek(Log, sseek + (eseek - sseek) / (SAOFF_T)2L, SEEK_SET, cfg.log_file);
	    /* Align to next record start */
	    READ_ALIGN(Log);
	    /* Save real record start position */
	    rseek = SAftell(Log);
	    /* Read record time */
	    if (!READ_DT(Log, &ttime)) SAexit("Can't read log");
#if DEBUG >= 1
	    SAdebug("Range %lld <-> %lld, %ld %s %ld position=%lld", (long long int)sseek, (long long int)eseek, ttime, (ttime >= sdate) ? ">=" : "< ", sdate, (long long int)rseek);
#endif
	    if (ttime >= sdate) eseek = rseek;
	    else sseek = rseek;
	}
#if DEBUG >= 1
	SAdebug("Pre-final range %lld <-> %lld", (long long int)sseek, (long long int)eseek);
#endif
	/* Find position with requested date sequentally
	   (sseek always points to aligned record) */
	SAfseek(Log, sseek, SEEK_SET, cfg.log_file);
	do {
	    rseek = SAftell(Log);
	    if (!READ_DT(Log, &ttime)) SAexit("Can't read log");
#if DEBUG >= 1
	    SAdebug("Position=%lld, date=%ld", rseek, ttime);
#endif
	} while (ttime < sdate);
	/* Recover position */
	SAfseek(Log, rseek, SEEK_SET, cfg.log_file);
#if DEBUG >= 1
	SAdebug("Final position found: %lld", (long long int)rseek);
#endif
    } else SAwarning("Non-linear and/or non-seekable log format detected, can't seek for fast data processing");

    return 0;
}


/* Function initial/finish log position: start/end */
void ShowLogI(FILE *Log, time_t *mindate, time_t *maxdate) {
    time_t ttime;


    *mindate = SAMAXTIMET;
    *maxdate = 0L;

    if (LogFormats[cfg.log_format].mode == 3) { /* Log file is linear and seekable */
	/* Read first record date */
	if (!READ_DT(Log, &ttime)) SAexit("Can't read log");
	*mindate = ttime;
	
	/* For next function call we need log file size */
	SAfseek(Log, 0L, SEEK_END, cfg.log_file);
	
	/* If log is not short we rewind it to prelast records */
	if (SAftell(Log) >= (SAOFF_T)RECORDSIZE) SAfseek(Log, -((SAOFF_T)RECORDSIZE), SEEK_END, cfg.log_file);
	else rewind(Log);
	
	READ_ALIGN(Log);
	while(READ_DT(Log, &ttime));
	*maxdate = ttime;
    } else while(READ_DT(Log, &ttime)) {
	if (ttime < *mindate) *mindate = ttime;
	if (ttime > *maxdate) *maxdate = ttime;
    }
}


/* Function initial/finish log position: start/end */
void ShowLog(FILE *Log) {
    time_t mindate, maxdate;

    ShowLogI(Log, &mindate, &maxdate);
    SAshow("Log file information:\n\
File name:\t\t%s\n\
File size:\t\t%s\n\
Start date and time:\t%s\n\
",
    cfg.log_file, (SAgetbit(LogFormats[cfg.log_format].mode, 0)) ? SAB0(SAftell(Log) + 0.0) : "Unknown (FIFO?)", GetDT(mindate, "%x %X"));
    /* Because GetDT is not volatile */
    SAshow("End date and time:\t%s\n", GetDT(maxdate, "%x %X"));
}


/* Function initial/finish log position: start/log is closed within this function */
void CropLog(FILE *Log) {
    time_t ttime;
    FILE *tLog;
    char *tbuf, tfname[FILENAMESIZE];


    SAsnprintf(tfname, sizeof(tfname), "%s.new", cfg.log_file);
    tLog = SAfopenI("w", tfname);

    tbuf = (char *)SAmalloc(RECORDSIZE);
    while (READ_FULLDT(Log, &ttime, tbuf)) {
	/* Skip records in specified date range */
	if (ttime >= icfg.SDate && ttime <= icfg.EDate) continue;
	
	SAfwrite1(tbuf, strlen(tbuf), tLog);
	SAfwrite1("\n", 1L, tLog);
    }
    free(tbuf);

    SAfclose(tLog);
    SAfcloseU(Log, cfg.log_file);
    if (rename(tfname, cfg.log_file)) SAexit("Can't rename %s to %s. %s", tfname, cfg.log_file, strerror(errno));
}


/* Function initial/finish log position: start/start */
FILE *InitLog(void) {
    FILE *retval;
    struct stat tstat;


    retval = SAfopenI("r", cfg.log_file);
    if (fstat(fileno(retval), &tstat) == -1) SAexit("Can't stat %s", cfg.log_file);
    if (S_ISFIFO(tstat.st_mode)) {
	SAwarning("Log file is FIFO pipe, switching to non-seekable mode");
	SAclrbit(LogFormats[cfg.log_format].mode, 0);
    }

    /* Set READ_RECORD for manually specified log format (others - for all) */
    READ_RECORDM = LogFormats[cfg.log_format].ReadRecordM;
    READ_RECORDI = LogFormats[cfg.log_format].ReadRecord;
    READ_DTI = LogFormats[cfg.log_format].ReadDT;
    READ_FULLDTI = LogFormats[cfg.log_format].ReadFullDT;
    READ_ALIGN = LogFormats[cfg.log_format].ReadAlign;


    return retval;
}


char READ_RECORD(FILE *Log, time_t *ttime, double *tSeconds, char *tip, short int *tcode, double *tBytes, char *tmethod, char *turl, char *tname, char *tstat) {
    char retval = READ_RECORDI(Log, ttime, tSeconds, tip, tcode, tBytes, tmethod, turl, tname, tstat);
    *ttime += cfg.log_time_zone_shift;

    return retval;
}


char READ_DT(FILE *Log, time_t *ttime) {
    char retval = READ_DTI(Log, ttime);
    *ttime += cfg.log_time_zone_shift;

    return retval;
}


char READ_FULLDT(FILE *Log, time_t *ttime, char *tbuf) {
    char retval = READ_FULLDTI(Log, ttime, tbuf);
    *ttime += cfg.log_time_zone_shift;

    return retval;
}
