extern int pval;


extern size_t strlcpy(char *dst, const char *src, size_t size);
extern size_t strlcat(char *dst, const char *src, size_t size);
#if DEBUG >= 1
extern size_t strlcpyd(char *dst, const char *src, size_t size);
extern size_t strlcatd(char *dst, const char *src, size_t size);
#endif

extern int ErrOut(const char Mode, const char *func, const char *fmt, ...);
extern void SAshow(const char *fmt, ...);
extern void SAsystem(const char *program, ...);
extern void *SAmalloc(size_t size);
extern void *SArealloc(void *ptr, size_t size);
extern char *SAstrdup(const char *src);
extern char *SAstrldup(const char *src, size_t size);
extern int SApstrcmp(const char **el1, const char **el2);
extern char *SAsetlocale(int category, const char *locale);
extern time_t SAmktime(struct tm *tm);
extern struct tm *SAlocaltime(const time_t *timep);


#if DEBUG >= 1
#define SAstrlcpy strlcpyd
#define SAstrlcat strlcatd
#else
#define SAstrlcpy strlcpy
#define SAstrlcat strlcat
#endif

#define SAwarning(...)		ErrOut(2, __SAINFO__, __VA_ARGS__)
#define SAdebug(...)		ErrOut(1, __SAINFO__, __VA_ARGS__)
#define SAexit(...)		ErrOut(0, __SAINFO__, __VA_ARGS__)

#define SAfprintf(...)		( ((pval = fprintf(__VA_ARGS__))   < 0) ? SAexit("") : pval )
#define SAvfprintf(...)		( ((pval = vfprintf(__VA_ARGS__))  < 0) ? SAexit("") : pval )
#define SAsnprintf(...)		( ((pval = snprintf(__VA_ARGS__))  < 0) ? SAexit("") : pval )
#define SAvsnprintf(...)	( ((pval = vsnprintf(__VA_ARGS__)) < 0) ? SAexit("") : pval )

#if DEBUG >= 1
#define SDEBUG() SAdebug("Entering")
#define EDEBUG() SAdebug("Exiting")
#else
#define SDEBUG()
#define EDEBUG()
#endif
